<?php 

/*
Plugin Name: World of Warcraft Progression Display
Plugin URI: http://jamestombs.co.uk
Description: Plugin for displaying a guilds progression in World of Warcraft
Author: James Tombs
Version: 1.0
Author URI: http://jamestombs.co.uk
*/


function wow_progression_zones() {
	return array(
		'icecrown' => 'Icecrown Citadel',
		'argent' => 'Argent Coliseum',
		'ulduar' => 'Ulduar',
		'eye' => 'Eye of Eternity',
		'obsidian' => 'Obsidian Sanctum',
		'naxxramas' => 'Naxxramas',
		'vault' => 'Vault of Archavon',
		'blackwing' => 'Blackwing Descent',
    'twilight' => 'Bastion of Twilight',
    'fourwinds' => 'Throne of the Four Winds',
	);
}

function wow_progression_bosses() {
	return array(
		'icecrown' => array(
			'lord_marrowgar' => 'Lord Marrowgar',
			'deathwhisper' => 'Deathwhisper',
			'gunship_battle' => 'Gunship Battle',
			'saurfang' => 'Saurfang',
			'festergut' => 'Festergut',
			'rotface' => 'Rotface',
			'prof_putricide' => 'Prof Putricide',
			'blood_princess' => 'Blood Princess',
			'lanathel' => 'Lana\'thel',
			'valithria' => 'Valithria',
			'sindragosa' => 'Sindragosa',
			'the_lich_king' => 'The Lich King',
		),
		'argent' => array(
			'gormok' =>'Gormok',
			'acidmaw' => 'Acidmaw',
			'dreadscale' => 'Dreadscale',
			'icehowl' => 'Icehowl',
			'lord_jaraxxus' => 'Lord Jaraxxus',
			'edyis_darkbane' => 'Edyis Darkbane',
			'fjola_lightbane' => 'Fjola Lightbane',
			'anubarak' => 'Anub\'arak',
		),
		'ulduar' => array(
			'flame_leviathan' => 'Flame Leviathan',
			'razorscale' => 'Razorscale',
			'ignus' => 'Ignus',
			'xt002' => 'XT-002',
			'iron_council' => 'Iron Council',
			'kologarn' => 'Kologarn',
			'auraiya' => 'Auraiya',
			'hodir' => 'Hodir',
			'thorim' => 'Thorim',
			'freya' => 'Freya',
			'mimiron' => 'Mimiron',
			'general_verax' => 'General Verax',
			'yogg_saron' => 'Yogg-Saron',
			'algalon' => 'Algalon',
		),
		'eye' => array(
			'malygos' => 'Malygos',
		),
		'obsidian' => array(
			'sartharion' => 'Sartharion',
			'plus_1_drake' => '+1 Drake',
			'plus_2_drakes' => '+2 Drakes',
			'plus_3_drakes' => '+3 Drakes',
		),
		'naxxramas' => array(
			'anubrekhan' => 'Anub\'Rekhan',
			'faerlina' => 'Faerlina',
			'maexxna' => 'Maexxna',
			'noth' => 'Noth',
			'heigan' => 'Heigan',
			'loatheb' => 'Loatheb',
			'razuvious' => 'Razuvious',
			'gothik' => 'Gothik',
			'four_horsemen' => 'Four Horsemen',
			'patchwerk' => 'Patchwerk',
			'grobbulus' => 'Grobbulus',
			'gluth' => 'Gluth',
			'thaddius' => 'Thaddius',
			'sapphiron' => 'Sapphiron',
			'kelthuzad' => 'Kel\'Thuzad',
		),
		'vault' => array(
			'archavon' => 'Archavon',
			'emalon' => 'Emalon',
			'koralon' => 'Koralon',
		),
		'blackwing' => array(
      'magmaw' => 'Magmaw',
      'omnitron' => 'Omnitron Defense System',
      'maloriak' => 'Maloriak',
      'atramedes' => 'Atramedes',
      'chimaeron' => 'Chimaeron',
      'nefarian' => 'Nefarian',
    ),
    'twilight' => array(
      'wyrmbreaker' => 'Halfus Wyrmbreaker',
      'valiona' => 'Valiona and Theralion',
      'ascendants' => 'Twilight Ascendants',
      'chogall' => 'Cho\'gall',
      'sinestra' => 'Sinestra',
    ),
    'fourwinds' => array(
      'conclave' => 'Conclave of Wind',
      'alakir' => 'Al\'Akir',
    ),
	);
}

function wow_progression_actions() {
	add_options_page('WoW Progression', 'WoW Progression', 'manage_options', 'wow_progression-group', 'wow_progression_settings');
}

if (is_admin()) {
	add_action('admin_menu', 'wow_progression_actions');
	add_action('admin_init', 'register_wow_progression_settings');
}

function register_wow_progression_settings() {
	$zones = wow_progression_zones();
	$bosses = wow_progression_bosses();
	$difficulties = array(
		'normal25' => 'Normal 25',
		'hard25' => 'Hard 25',
		'normal10' => 'Normal 10',
		'hard10' => 'Hard 10',
	);
	foreach ($zones as $zone => $zone_name) {
		register_setting('wow_progression-group', 'show-'. $zone);
		foreach ($bosses[$zone] as $boss => $boss_name) {
			foreach ($difficulties as $difficulty => $diff_name) {
				register_setting('wow_progression-group', $boss .'-'. $difficulty);
			}
		}
	}
}

function wow_progression_settings() {
	$zones = wow_progression_zones();
	$bosses = wow_progression_bosses();
  $difficulties = array(
    'normal25' => 'Normal 25',
    'hard25' => 'Hard 25',
    'normal10' => 'Normal 10',
    'hard10' => 'Hard 10',
  );
?>
<div class="wrap">
<h2>World of Warcraft Progression Settings</h2>

<form method="post" action="options.php">
	<?php settings_fields( 'wow_progression-group' );
?>
<table class="form-table"><?php
foreach ($zones as $zone => $zone_name) { ?>

	<tr valign="top">
	<th scope="row">Show <?php echo $zone_name; ?></th>
	<td><input type="checkbox" name="show-<?php echo $zone; ?>[]" <?php checked( (bool) get_option('show-'. $zone), true ); ?> value="<?php echo get_option("show-". $zone); ?>" /></td>
	</tr>
<?php } ?>
</table>

<?php foreach ($zones as $zone => $zone_name) { ?>
<h3><?php echo $zone_name; ?></h3>
<table class="widefat">
  <thead><tr class="alternate"><th width="20%">Boss name</th><th width="20%">Normal 25</th><th width="20%">Hard 25</th><th width="20%">Normal 10</th><th width="20%">Hard 10</th></tr></thead><tbody>
	<?php foreach ($bosses[$zone] as $boss => $boss_name) { ?>
		<tr valign="top">
			<th scope="row"><?php echo $boss_name; ?></th>
      <?php foreach ($difficulties as $difficulty => $diff_name) { ?>
        <td><input type="checkbox" <?php checked( (bool) get_option($boss .'-'. $difficulty), true ); ?> name="<?php echo $boss; ?>-<?php echo $difficulty; ?>[]" value="<?php echo get_option($boss .'-'. $difficulty); ?>" />
      <?php } ?>
		</tr>
	<?php } ?>
</tbody></table>

<?php } ?>
    
    <p class="submit">
      <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>
</div>
<?php 

}

function wow_blocks_progression_class($value) {
	if (!is_array($value) || $value == '') {
		return 'noncomplete';
	}
	return 'complete';
}


function wow_progression_show_block() {
	$output = '';
	$zones = wow_progression_zones();
	$bosses = wow_progression_bosses();
        $output = '<div class="wow-progression">';

	foreach ($zones as $zone => $zone_name) {
		$option = get_option('show-'. $zone);
		if (!is_array($option) || $option == '') {
			unset($zones[$zone]);
		}
	}
	foreach ($zones as $zone => $zone_name) {
		$output .= '<div class="'. $zone .'-wrapper wow-progression-wrapper">';
		$output .= '<table width="100%" id="'. $zone .'-clicker" class="wow-progression-clicker" cellspacing="0" cellpadding="0" border="0"><tr><td colspan="2" width="30"><span>25</span></td><td align="center"><strong>'. $zone_name .'</strong></td><td colspan="2" align="right" width="30"><span>10</span></td></tr></table>';
		$output .= '<table width="100%" id="'. $zone .'-bosses" class="wow-progression-bosses" cellspacing="0" cellpadding="0" border="0">';
		foreach ($bosses[$zone] as $boss => $boss_name) {
			$output .= '<tr>';
			$output .= '<td width="15"><span class="'. wow_blocks_progression_class(get_option($boss .'-hard25')) .'">H</span></td>';
			$output .= '<td width="15"><span class="'. wow_blocks_progression_class(get_option($boss .'-normal25')) .'">N</span></td>';
			$output .= '<td align="center">'. $boss_name .'</td>';
			$output .= '<td width="15"><span class="'. wow_blocks_progression_class(get_option($boss .'-normal10')) .'">N</span></td>';
			$output .= '<td width="15"><span class="'. wow_blocks_progression_class(get_option($boss .'-hard10')) .'">H</span></td>';
			$output .= '</tr>';
		}

		$output .= '</table>';
		$output .= '</div>';
	}
	$output .= '</div>';
	echo $output;
}
 
function widget_wow_progression($args) {
  extract($args);
  echo $before_widget;
  echo $before_title;?>Progression<?php echo $after_title;
  wow_progression_show_block();
  echo $after_widget;
}
 
function wow_progression_init()
{
  register_sidebar_widget(__('WoW Progression'), 'widget_wow_progression');
}
add_action("plugins_loaded", "wow_progression_init");

function wow_progression_scripts() {
	wp_enqueue_script('jquery');
	wp_enqueue_script('wow_progression', WP_CONTENT_URL . '/plugins/wow_progression/wow_progression.js');
}

function wow_progression_styles() {
	wp_enqueue_style('wow_progression', WP_CONTENT_URL . '/plugins/wow_progression/wow_progression.css');
}

add_action( 'wp_print_scripts', 'wow_progression_scripts' );
add_action( 'wp_print_styles', 'wow_progression_styles' );
?>